// the classes

class Dash
{
   sndbuf d; 
   JCRev n; 
   dur len;

   1.5 => d.gain; 
   "data/snare.wav" => d.read;
   2.0 => d.play; 
   0.3 => n.mix; 
   1.5 => n.gain;
   240::ms => len;
   d => n;

   fun void play()
   {
      n => dac;
      0 => d.pos; 
      len => now;
      n =< dac;
   }

   fun void play( int ntimes )
   {
      n => dac;
      for( 0 => int count; count < ntimes; count++ )
      {
         0 => d.pos; 
         len => now;
      }
      n =< dac;
   }
}          

class Dot 
{
   sndbuf d;
   dur len;

   1.5 => d.gain;
   "data/snare.wav" => d.read;
   1.0 => d.play; 
   120::ms => len;
   d => dac;

   fun void play()
   {
      0 => d.pos; 
      len => now;
   }

   fun void play( int ntimes )
   {
      for( 0 => int count; count < ntimes; count++ )
      {
         0 => d.pos;
         len => now;
      }
   }
}

Dash dash; 
Dot dot; 
dash.len => dur end;

fun void a() {
   <<< "a = .-" >>>; 
   dot.play();
   dash.play();
   end => now;
}

fun void b() {
   <<< "b = -..." >>>;
   dash.play();
   dot.play(3);
   end => now;
}

fun void c() {
   <<< "c = -.-." >>>;
   dash.play();
   dot.play();
   dash.play();
   dot.play();
   end => now;
}

fun void d() {
   <<< "d = -.." >>>;
   dash.play();
   dot.play(2);
   end => now;
}

fun void e() {
   <<< "e = ." >>>;
   dot.play();
   end => now;
}

fun void f() {
   <<< "f = ..-." >>>;
   dot.play(2);
   dash.play(1); 
   dot.play(1); 
   end => now;
}

fun void g() {
   <<< "g = --." >>>;
   dash.play(2);
   dot.play();
   end => now;
}

fun void h() {
   <<< "h = ...." >>>;
   dot.play(4);
   end => now;
}

fun void i() {
   <<< "i = .." >>>;
   dot.play(2);
   end => now;
}

fun void j() {
   <<< "j = .---" >>>;
   dot.play();
   dash.play(3);
   end => now;
}

fun void k() {
   <<< "k = -.-" >>>;
   dash.play();
   dot.play();
   dash.play();
   end => now;
}

fun void l() {
   <<< "l = .-.." >>>;
   dot.play();
   dash.play();
   dot.play(2);
   end => now;
}

fun void m() {
   <<< "m = --" >>>;
   dash.play(2);
   end => now;
}

fun void n() {
   <<< "n = -." >>>;
   dash.play();
   dot.play();
   end => now;
}

fun void o() {
   <<< "o = ---" >>>;
   dash.play(3);
   end => now;
}

fun void p() {
   <<< "p = .--." >>>;
   dot.play(); 
   dash.play(2);
   dot.play();
   end => now;
}

fun void q() {
   <<< "q = --.-" >>>;
   dash.play(2);
   dot.play();
   dash.play();
   end => now;
}

fun void r() {
   <<< "r = .-." >>>;
   dot.play();
   dash.play();
   dot.play();
   end => now;
}

fun void s() {
   <<< "s = ..." >>>;
   dot.play(3); 
   end => now;
}

fun void t() {
   <<< "t = -" >>>;
   dash.play();
   end => now;
}

fun void u() {
   <<< "u = ..-" >>>;
   dot.play(2);
   dash.play();
   end => now;
}

fun void v() {
   <<< "v = ...-" >>>;
   dot.play(3);
   dash.play();
   end => now;
}

fun void w() {
   <<< "w = .--" >>>;
   dot.play();
   dash.play(2);
   end => now;
}

fun void x() {
   <<< "x = -..-" >>>;
   dash.play();
   dot.play(2);
   dash.play();
   end => now;
}

fun void y() {
   <<< "y = -.--" >>>;
   dash.play();
   dot.play();
   dash.play(2);
   end => now;
}

fun void z() {
   <<< "z = --.." >>>;
   dash.play(2);
   dot.play(2);
   end => now;
}

fun void space()
{
   <<< "space" >>>; 
   2 * end => now;
}

// stolen goods
fun void otf_06()
{
   // synchronize to period
   .5::second => dur T; 
   T - (now % T) => now; 
   sinosc s => JCRev r => dac;
   .05 => s.gain;
   .25 => r.mix;
   // scale (in semitones)
   [0, 2, 4, 7, 9] @=> int scale[]; 
   // infinite time loop
   while( true )
   {
      // get note class
      scale[ math.rand2(0,4) ] => float freq;
      // get the final freq
      std.mtof( 69 + std.rand2(0,3)*12 + freq ) => s.freq;
      // reset phase for extra bandwidth
      0 => s.phase;
      // advance time 
      if( std.randf() > -.5 ) 
         .25::T => now;
      else
         .5::T => now;
   }
}


// obvious message
h(); a(); p(); p(); y(); space();
b(); i(); r(); t(); h(); d(); a(); y(); space();
g(); e(); space(); space();
w(); i(); s(); h(); i(); n(); g(); space();
y(); o(); u();
spork ~ otf_06(); space(); space(); 
l(); o(); l(); o(); f(); space(); 
a(); n(); d(); space(); 
t(); h(); e(); space(); 
b(); e(); s(); t(); space(); 
o(); f(); space();
e(); v(); e(); r(); y(); t(); h(); i(); n(); g();
space(); space(); space(); space(); 
